// Generated by LiveScript 1.5.0
var red, EventEmitter, ref$, templatesPath, callArgs, fs, yaml, ObservableProcess, path, last, requireYaml, cp, DockerSetup;
red = require('chalk').red;
EventEmitter = require('events').EventEmitter;
ref$ = require('exosphere-shared'), templatesPath = ref$.templatesPath, callArgs = ref$.callArgs;
fs = require('fs');
yaml = require('js-yaml');
ObservableProcess = require('observable-process');
path = require('path');
last = require('prelude-ls').last;
requireYaml = require('require-yaml');
cp = require('shelljs').cp;
DockerSetup = (function(superclass){
  var prototype = extend$((import$(DockerSetup, superclass).displayName = 'DockerSetup', DockerSetup), superclass).prototype, constructor = DockerSetup;
  function DockerSetup(arg$){
    this.name = arg$.name, this.logger = arg$.logger, this.config = arg$.config;
    this.write = bind$(this, 'write', prototype);
    this._dockerFileExists = bind$(this, '_dockerFileExists', prototype);
    this._buildDockerImage = bind$(this, '_buildDockerImage', prototype);
    this.start = bind$(this, 'start', prototype);
    this.serviceConfig = this.config ? require(path.join(this.config.root, 'service.yml')) : void 8;
  }
  DockerSetup.prototype.start = function(done){
    switch (false) {
    case !!this._dockerFileExists():
      cp(path.join(templatesPath, 'docker', 'Dockerfile'), path.join(this.config.root, 'Dockerfile'));
    }
    this.logger.log({
      name: this.name,
      text: "preparing Docker image"
    });
    return this._buildDockerImage(done);
  };
  DockerSetup.prototype._buildDockerImage = function(done){
    var serviceName, x$, this$ = this;
    serviceName = last(
    this.config.root.split(path.sep));
    x$ = new ObservableProcess(callArgs("docker build --build-arg SERVICE_NAME=" + serviceName + " -t " + this.serviceConfig.author + "/" + serviceName + " ."), {
      cwd: this.config.root,
      stdout: {
        write: this.write
      },
      stderr: {
        write: this.write
      }
    });
    x$.on('ended', function(exitCode, killed){
      switch (false) {
      case exitCode !== 0:
        this$.logger.log({
          name: this$.name,
          text: "Docker setup finished"
        });
        break;
      default:
        this$.logger.log({
          name: this$.name,
          text: "Docker setup failed"
        });
        process.exit(exitCode);
      }
      return done();
    });
    return x$;
  };
  DockerSetup.prototype._dockerFileExists = function(){
    var e;
    try {
      return fs.accessSync(path.join(this.config.root, 'Dockerfile'));
    } catch (e$) {
      e = e$;
      return false;
    }
  };
  DockerSetup.prototype.write = function(text){
    return this.emit('output', {
      name: this.name,
      text: text,
      trim: true
    });
  };
  return DockerSetup;
}(EventEmitter));
module.exports = DockerSetup;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}